import timer from '../util/timer'
class DebuggerIns {
  constructor () {
    this.debuggerObj = {
      oldData: null,
      nowScriptId: -1,
      breakpoint: [],
      callFrame: []
    }
    this.breakpoints = {}
    this.status = false
  }

  /**
   * 添加到breakpoint中 只是为了代码中断。和breakpointId没有关系
   * @param {*} data
   */
  setBreakpoint (data) {
    const breakpoint = this.debuggerObj.breakpoint
    const item = breakpoint.find((e) => {
      return e.scriptId == data.scriptId && e.line === data.line
    })
    if (!item) {
      breakpoint.push(data)
    }
  }

  /**
   * 根据breakpointId删除中断信息
   * @param {*} id
   */
  removeBreakpoint (id) {
    const ele = this.breakpoints[id]
    if (ele) {
      const breakpoint = this.debuggerObj.breakpoint
      const index = breakpoint.findIndex((e) => {
        return e.scriptId == ele.scriptId && e.line === ele.line
      })
      this.debuggerObj.breakpoint.splice(index, 1)
      delete this.breakpoints[id]
    }
  }

  resume () {
    this.status = false
    $window.ServiceJSBridge.invoke('remoteDebuggerInterrupt', { interrupt: false, data: {} })
    timer.executeCallback()
  }
}

export default DebuggerIns
